



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>ES6 Symbol数据类型和set-map 数据结构</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">ES6 Symbol数据类型和set-map 数据结构</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-26 20:13:24 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>Symbol数据类型</p>
<p>ES6新加的数据类型，提供一个独一无二的值</p>
<div>
<pre class="prettyprint linenums">　{ let a1 = Symbol() ;let a2 = Symbol() }  //声明<br />
　{ let a3 = Symbol.for('a3') }  //这种声明方式方便再取回来<br />
　{ let a1=Symbol.for('abc'); let obj={ [a1]:'123' , 'abc':235}; console.log(obj) }  //{abc: "235", Symbol(abc): "123"}</pre>
</div>
<p>如果使用Symbol配置值的话则使用let of 的方式取不到Symbol(abc)的值</p>
<div>
<pre class="prettyprint linenums">　Object.getOwnPropertySymbols(obj).forEach(function(item){console.log(obj[item])});  //123 只取到Symbol的值</pre>
</div>
<p>取所有值：//Reflect.ownKeys返回一个数组,包含对象自身的所有属性,不管是属性名是Symbol或字符串,也不管是否可枚举</p>
<div>
<pre class="prettyprint linenums">Reflect.ownKeys(obj).forEach(function(item){console.log(obj[item])})  //235  123</pre>
</div>
<p>set-map 数据结构</p>
<p>set</p>
<p>① 声明</p>
<p>不加参数 ：</p>
<div>
<pre class="prettyprint linenums">{ let list = new Set(); list.add(5) ; list.add(7); }  //list.size()是2</pre>
</div>
<p>加参数 ：</p>
<div>
<pre class="prettyprint linenums">{ let arr= [1,2,3,4,5]; let list = new Set(arr) }  //list.size()是5</pre>
</div>
<p>② set添加重复的元素不会报错，但是不会添加进去，可以利用这个作用来去重（需要注意下元素的数据类型是否一致）</p>
<div>
<pre class="prettyprint linenums">{ let list = new Set(); list.add(5) ; list.add(7); list.add(5); }  //list.size()是2</pre>
</div>
<p>③ 操作函数 ：</p>
<p><strong>add &nbsp;delete &nbsp;clear &nbsp;has</strong></p>
<p>④ 遍历：</p>
<p>元素的keys()和values()的值是一样的</p>
<div>
<pre class="prettyprint linenums">for(let key of list.keys()){ console.log(key) }<br />
for(let value of list.values()){ console.log(value) }<br />
for(let [key,value] of list.entries()){ console.log(key,value) }</pre>
</div>
<p>WeakSet</p>
<p>区别：</p>
<p>支持的元素类型不一样，WeakSet只能是对象；</p>
<p>WeakSet的对象是弱引用，不会检测该对象是否在其他地方用过，只是地址的引用；</p>
<p>没有size属性；没有clear方法；其余的add delete has 方法一致</p>
<p>不能遍历</p>
<p>①声明</p>
<div>
<pre class="prettyprint linenums">{ let weakset = new WeakSet() ; let arg ={} ; weakset.add(args) }</pre>
</div>
<p>Map 键值对</p>
<p>key可以是任何数据类型</p>
<p>①声明 ：</p>
<div>
<pre class="prettyprint linenums">{ let map = new Map(); let arr= ['123']; map.set(arr,'234'); }  //map.get(arr) = '234'

{ let map = new Map([ ['a',123],['b',456] ])}  //{"a"=&gt;123,"b"=&gt;456} ; map.size=2</pre>
</div>
<p>map不能set一个item对象，需要使用声明的第二种方式</p>
<p>②函数：<strong>set &nbsp;delete &nbsp;clear</strong></p>
<p>③遍历：同set</p>
<p>WeakMap</p>
<p>接收的key值必须是对象，没有clear方法，不能遍历</p>
<div>
<pre class="prettyprint linenums">{ let weakmap = new WeakMap() ; let obj={}; weakmap.set(obj,123)}  //weakmap.get(obj)=123</pre>
</div>
<p>对比：</p>
<p>Set Map与Array对比</p>
<div>
<pre class="prettyprint linenums">let set= new Set() ; let map = new Map() ; let arr = [] ;</pre>
</div>
<p>//增加</p>
<div>
<pre class="prettyprint linenums">set.add({t:1});<br />
map.set('t',1);<br />
arr.push({t:1}) </pre>
</div>
<p>//查找</p>
<div>
<pre class="prettyprint linenums">let set_exists = list.has({t:1})  ///false ，has查询的是对象的引用<br />
let map_exists = map.has(&lsquo;t&rsquo;)  //true 返回布尔值<br />
let arr_exists = array.find(item=&gt;item.t)  //{t:1} 返回对象</pre>
</div>
<p>//改</p>
<div>
<pre class="prettyprint linenums">set.forEach(item=&gt;item.t?item.t=2:'')  //在set中要是直接修改的话他不会检查是否冲突，而是直接加了一个，所以需要先找到再修改<br />
map.set('t',2);<br />
array.forEach(item=&gt;item.t?item.t=2:'')  //数组需要先forEach找到再修改</pre>
</div>
<p>//删除</p>
<div>
<pre class="prettyprint linenums">set.forEach(item = item.t?set.delete(item):'')<br />
map.delete('t')<br />
let index = array.findIndex(item=&gt;item.t)  array.splice(index,1) //数组需要先找到再删</pre>
</div>
<p>Map Set 和Array的对比</p>
<div>
<pre class="prettyprint linenums">let item = {t:1}; let set= new Set(); let map = new Map(); let obj={}</pre>
</div>
<p>//增加</p>
<div>
<pre class="prettyprint linenums">set.add(item)<br />
map.set('t',1)<br />
obj['t']:1</pre>
</div>
<p>//查询</p>
<div>
<pre class="prettyprint linenums">set.has(item)  //<br />
map.has('t')<br />
't' in obj  //使用in</pre>
</div>
<p>//删除</p>
<div>
<pre class="prettyprint linenums">set.delete(item)<br />
map.delete('t')<br />
delete obj['t']</pre>
</div>
<p>//修改</p>
<div>
<pre class="prettyprint linenums">item.t =2 //set是引用，直接修改item，set下的值会随之变化<br />
map.set('t':4)<br />
obj['t']=4</pre>
</div>
<p>使用场景：</p>
<p>能使用map的不使用数组，对于数据要求比较高和唯一性使用set，放弃object</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/rqlowv1q.html">poj 3264（线段树）</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvkxey9.html">对CPU做下性能测试</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv1e1xq.html">MongoDB 查询 &lpar;转&rpar;  仅限于C&plus;&plus;开发</a>
		</li>
						<li><a href="https://www.batexi.com/a/95xje668.html">LLVM language 参考手册（译）（4）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1kj128.html">20160127 linux 学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jz2y5w8.html">document&period;getElementById&lpar;&amp;quot&semi;searchForm&amp;quot&semi;&rpar;&period;submit is not a function</a>
		</li>
						<li><a href="https://www.batexi.com/a/8kpko5r9.html">框架整合&mdash;&mdash;Spring与MyBatis框架整合</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjxy638.html">【转】nagios 命令解释</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxkmznv8.html">Java内存模型&lowbar;volatile</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlj4rvk9.html">&lpar;模拟&rpar; codeVs1083  &amp;amp&semi;&amp;amp&semi; 洛谷P1014  Cantor表</a>
		</li>
						<li><a href="https://www.batexi.com/a/950543e8.html">flask实战-留言板-Web程序开发流程</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjowrjq.html">清除mac出现的&period;DS&lowbar;Store文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp36jk9.html">IIS7配置下载apk以及目录浏览</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ppgxxz9.html">Eclipse C&plus;&plus;&comma;Cygwin 64&comma;gcov&comma;lcov   单体&amp;amp&semi;覆盖率测试环境搭建笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/953d6m08.html">PHP 运行相关概念</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gpvl279.html">Java异常封装</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r45jyr8.html">使用SAP C4C rule editor动态控制UI上某个按钮是否显示</a>
		</li>
						<li><a href="https://www.batexi.com/a/93j6wr08.html">Unity和Lua交互</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jexmxl8.html">&lbrack;模板&rsqb;BZOJ4756线段树合并</a>
		</li>
						<li><a href="https://www.batexi.com/a/95poen6q.html">LeetCode：乘法表中的第K小的数【668】</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pdzrmz9.html">完全卸载删除gitlab</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpwxy39.html">springMVC下载中文文件名乱码【转】</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oj7zwxq.html">gdb常用命令及gdb调试多进程&sol;线程程序&amp;amp&semi;coredump</a>
			</li>
						<li><a href="https://www.batexi.com/a/9jzkwk48.html">为什么用Flow</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpwwlr9.html">Javascript我学之二函数定义</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnj33pk8.html">RxJS操作符（一）</a>
			</li>
						<li><a href="https://www.batexi.com/a/8kpw3x79.html">logrotate命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7zpm2j9.html">&lbrack;NewLife&period;XCode&rsqb;高级增删改</a>
			</li>
						<li><a href="https://www.batexi.com/a/8meon5pq.html">Ubuntu文件写入内容时出现错误 E121&colon;无法打开并写入文件解决方案</a>
			</li>
						<li><a href="https://www.batexi.com/a/q1kgze49.html">译：Dataiku 白皮书之《在银行和保险行业应用数据科学》</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
